# 1. Create Pandas Dataframe
from IPython.display import display
import pandas as pd
import numpy as np

#1. 데이터프레임 생성(numpy)

my_array = np.array([[1, 2, 3], [4, 5, 6]])
my_df=pd.DataFrame(my_array)

display(my_df)
print('\n')


#2. 데이터프레임 생성(dictionary)

my_dict = {"a": ['1', '3'], "b": ['1', '2'], "c": ['2', '4']}
my_df = pd.DataFrame(my_dict)

display(my_df)
print('\n')


#3. 데이터프레임 생성(data, index, column을 지정)

my_df = pd.DataFrame(data=np.array([[1, 2, 3], [4, 5, 6], [7, 8, 9]]), index= [2.5, 12.6, 4.8], columns=[48, 49, 50])
display(my_df)
print('\n')

#4. 데이터프레임 생성(Series)

my_series = pd.Series({"United Kingdom":"London", "India":"New Delhi", "United States":"Washington", "Belgium":"Brussels"}) # 데이터 프레임의 한컬럼 한컬럼이 시리즈이다.

display(pd.DataFrame(my_series))

#5. 데이터프레임의 Shape 및 길이 구하기

df = pd.DataFrame(np.array([[1, 2, 3], [4, 5, 6]]))

display(df.shape)
display(len(df.index))

#6. 데이터프레임의 컬럼 및 인덱스 구하기

df = pd.DataFrame(np.array([[1, 2, 3], [4, 5, 6]]))
a = list(df.columns)
b = list(df.index)

display(a)
display(b)
print('\n')


#7. 데이터프레임의 행(로우) 인덱싱

df = pd.DataFrame({"A":[1,2,3],"B":['a','d','g'], "C":['b','e','h'], "D":['c','f','i']})
df = df.set_index('A')

display(df)
display(df.iloc[1])  # iloc는 0,1에서 1번째 행을 참조하지만 loc와 ix는 index이름인 1을 참조하여 시리즈를 반환한다.
display(df.loc[1])
display(df.ix[1])
print('\n')

#8. 데이터프레임의 열(컬럼) 인덱싱

df = pd.DataFrame({"A":[1,4,7], "B":[2,5,8], "C":[3,6,9]})

display(df)
display(df.loc[:,'A'])
display(df['A'])
print('\n')

#9. 데이터프레임의 로우, 컬럼 인덱싱(특정 값)

df = pd.DataFrame({"A":[1,4,7], "B":[2,5,8], "C":[3,6,9]})

display(df.ix[0]['B'])
display(df.loc[0]['B'])
display(df.iloc[0][1])
print('\n')

#10. 데이터프레임의 데이터프레임 반환
df = pd.DataFrame({"A":[1,4,7], "B":[2,5,8], "C":[3,6,9]})

display(df.loc[0:1,:'B'])
print('\n')

#11. 인덱스 설정하기
df = pd.DataFrame({"A":[1,4,7], "B":[2,5,8], "C":[3,6,9]})
display(df)

df = df.set_index('A')
display(df)
print('\n')

#12. 로우 추가하기(행지정)
df = pd.DataFrame(data=np.array([[1, 2, 3], [4, 5, 6], [7, 8, 9]]), index= [2.5, 12.6, 4.8], columns=[48, 49, 50])
display(df)

df.ix[2] = [60, 50, 40] # There's no index labeled `2`, so you will change the index at position `2`
display(df)

df.loc[2] = [11, 12, 13] # This will make an index labeled `2` and add the new values
display(df)
print('\n')

#13. 로우 추가하기(맨뒤에 - dataframe을 만들어서 추가하는 형태)

df = pd.DataFrame(data=np.array([[1, 2, 3], [4, 5, 6], [7, 8, 9]]), columns=[48, 49, 50])
display(df)

a = pd.DataFrame(data=[[1,2,3]], columns=[48,49,50])
display(a)

df = df.append(a)
display(df)

df = df.reset_index(drop=True) # 인덱스를 재배열한다 (이전 인덱스 삭제)
display(df)
print('\n')

#14. 컬럼 추가하기

df = pd.DataFrame(data=np.array([[1, 2, 3], [4, 5, 6], [7, 8, 9]]), columns=['A', 'B', 'C'])

# Study the DataFrame `df`
display(df)

df.loc[:, 'D'] = pd.Series(['5', '6', '7'], index=df.index) # loc함수를 통한 Series추가

# Print out `df` again to see the changes
display(df)

df['E'] = pd.Series(['5', '6', '7'], index=df.index) # 컬럼명을 지정하여 Series추가
display(df)

display(df['E'])
print('\n')

#15. 열 삭제

df = pd.DataFrame(data=np.array([[1, 2, 3], [4, 5, 6], [7, 8, 9]]), columns=['A', 'B', 'C'])
display(df)

df.drop('A', axis=1, inplace=True) # drop axis의 경우 column이면 1, row이면 0이다.
display(df)
print('\n')

#16. 중복 로우 삭제

df = pd.DataFrame(data=np.array([[1, 2, 3], [4, 5, 6], [7, 8, 9], [40, 50, 60], [23, 35, 37]]),
                  index= [2.5, 12.6, 4.8, 4.8, 2.5],
                  columns=[48, 49, 50])
display(df)

df = df.reset_index() # 인덱스열을 신규로 생성하고 기존 인덱스는 'index'라는 컬럼값을 가진 열로 변경된다.
display(df)

df = df.drop_duplicates(subset='index', keep='last').set_index('index') # 컬럼명이 index인 중복된 로우를 둘다 삭제하고 'index'명을 가진 컬럼을 인덱스로 다시 바꿈
display(df)
print('\n')

#17. 인덱스를 통한  로우 삭제
df = pd.DataFrame(data=np.array([[1, 2, 3], [1, 5, 6], [7, 8, 9]]), columns=['A', 'B', 'C'])
display(df)
print('\n')

print(df.index[1])
df = df.drop(df.index[1])
display(df)

df = pd.DataFrame(data=np.array([[1, 2, 3], [1, 5, 6], [7, 8, 9]]), columns=['A', 'B', 'C'])
df = df.drop(0)
display(df)
print('\n')

#18. 데이터 수정하기

df = pd.DataFrame(data=np.array([[1, 2, 3], [1, 5, 6], [7, 8, 9]]), columns=['A', 'B', 'C'])
display(df)

df.ix[0]['A'] = 0
display(df)

